//
//  EnxFaceX.h
//  EnxFaceXiOS
//
//  Created by Daljeet Singh on 12/08/20.
//  Copyright © 2020 VcloudX Pvt. Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <EnxRTCiOS/EnxRTCiOS.h>
NS_ASSUME_NONNULL_BEGIN
@class EnxFaceAI;

#pragma mark - FaceX APIs
@protocol EnxFaceAIDelegate <NSObject>
@optional
/**
Delegate to give data for facial expressions
*/
/*
 This delegate method will inform about face feature.
 */
- (void)faceai:(EnxFaceAI *_Nullable)faceai didFaceFeaturesData:(NSString *_Nullable)type value:(NSString *_Nullable)value;
/*
 This delegate method will inform about face feature like angery or sad etc...
 */
- (void)faceai:(EnxFaceAI *_Nullable)faceai didFaceArousalValenceData:(NSString *_Nullable)type value:(NSString *_Nullable)value;
/*
 This delegate method will inform about face feature like attention
 */
- (void)faceai:(EnxFaceAI *_Nullable)faceai didFaceAttentionData:(NSString *_Nullable)type value:(NSString *_Nullable)value;
/*
 This delegate method will inform about face feature like age
 */
- (void)faceai:(EnxFaceAI *_Nullable)faceai didFaceAgeData:(NSString *_Nullable)type value:(NSString *_Nullable)value;
/*
 This delegate method will inform about face feature like pose
 */
- (void)faceai:(EnxFaceAI *_Nullable)faceai didFacePoseData:(NSString *_Nullable)type value:(NSString *_Nullable)value;
/*
 This delegate method will inform about face feature like gender
 */
- (void)faceai:(EnxFaceAI *_Nullable)faceai didFaceGenderData:(NSString *_Nullable)type value:(NSString *_Nullable)value;
/*
 This delegate method will inform about face feature like Emotional
 */
- (void)faceai:(EnxFaceAI *_Nullable)faceai didFaceEmotionData:(NSString *_Nullable)type value:(NSString *_Nullable)value;
/*
 This delegate method will inform about face feature like attention
 */
- (void)faceai:(EnxFaceAI *_Nullable)faceai didFaceDetectorData:(NSString *_Nullable)type value:(NSString *_Nullable)value;
/*
 This delegate method will inform about face feature like attention
 */
- (void)faceai:(EnxFaceAI *_Nullable)faceai didFaceWishData:(NSString *_Nullable)type value:(NSString *_Nullable)value;

- (void)faceai:(EnxFaceAI *_Nullable)faceai didFaceaiEventError:(NSDictionary *_Nullable)value;


@end


@interface EnxFaceAI : NSObject

@property (weak, nonatomic) id <EnxFaceAIDelegate> _Nullable delegate;
-(instancetype)initFaceX:(NSDictionary * _Nonnull)roomMeta room:(EnxRoom * _Nonnull)room stream:(EnxStream *)stream delegate:(id<EnxFaceAIDelegate>)delegate;

-(void)enableFaceFeatures:(BOOL)value;
-(void)enableFaceArousalValence:(BOOL)value;
-(void)enableFaceAttention:(BOOL)value;
-(void)enableFaceAge:(BOOL)value;
-(void)enableFacePose:(BOOL)value;
-(void)enableFaceGender:(BOOL)value;
-(void)enableFaceEmotion:(BOOL)value;
-(void)enableFaceDetector:(BOOL)value;
-(void)enableFaceWish:(BOOL)value;


@end

NS_ASSUME_NONNULL_END
